import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/custom-multiflipcard.dart';

///Widget Class
class TileData {
  ///parameter
  Widget leading;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  Widget trailing;

  ///parameter
  bool enabled;

  ///parameter
  bool selected;

  ///Constructor
  TileData(
      {this.leading,
      this.title,
      this.subtitle,
      this.trailing,
      this.enabled = true,
      this.selected = false});
}

///Widget Class
class ListTileParameters {
  ///parameter
  final bool isThreeLine;

  ///parameter
  final bool dense;

  ///parameter
  final EdgeInsetsGeometry contentPadding;

  ///parameter
  final GestureTapCallback onTap;

  ///parameter
  final GestureLongPressCallback onLongPress;

  ListTileParameters({
    this.isThreeLine = false,
    this.dense,
    this.contentPadding,
    this.onTap,
    this.onLongPress,
  });
}

///Widget Class
class CustomDividerParameters {
  ///parameter
  final double height;

  ///parameter
  final double thickness;

  ///parameter
  final double indent;

  ///parameter
  final double endIndent;

  ///parameter
  final Color color;

  const CustomDividerParameters({
    this.height,
    this.thickness,
    this.indent,
    this.endIndent,
    this.color,
  });
}

///Widget Class
class CustomToolTipparams {
  ///parameter
  final String message;

  ///parameter
  final Widget child;

  ///parameter
  final double height;

  ///parameter
  final EdgeInsetsGeometry padding;

  ///parameter
  final EdgeInsetsGeometry margin;

  ///parameter
  final double verticalOffset;

  ///parameter
  final bool preferBelow;

  ///parameter
  final bool excludeFromSemantics;

  ///parameter
  final Decoration decoration;

  ///parameter
  final TextStyle textStyle;

  ///parameter
  final Duration waitDuration;

  ///parameter
  final Duration showDuration;

  const CustomToolTipparams(
      {this.message,
      this.child,
      this.height,
      this.padding,
      this.margin,
      this.verticalOffset,
      this.preferBelow,
      this.excludeFromSemantics,
      this.decoration,
      this.textStyle,
      this.waitDuration,
      this.showDuration});
}

///Widget Class
class CustomLinearProgressBarParameters {
  ///parameter
  final double value;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Animation<Color> valueColor;

  ///parameter
  final String semanticsLabel;

  ///parameter
  final String semanticsValue;

  const CustomLinearProgressBarParameters({
    Key key,
    this.value,
    this.backgroundColor,
    this.valueColor,
    this.semanticsLabel,
    this.semanticsValue,
  });
}

///Widget Class
class CustomCircularProgressIndicatorParameters {
  ///parameter
  final double value;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Color valueColor;

  ///parameter
  final String semanticsLabel;

  ///parameter
  final String semanticsValue;

  CustomCircularProgressIndicatorParameters(
      {this.value,
      this.backgroundColor,
      this.valueColor,
      this.semanticsLabel,
      this.semanticsValue});
}

///Widget Class
class Products {
  ///parameter
  String imagepath;

  ///parameter
  String text1;

  ///parameter
  String text2;

  ///parameter
  String text3;

  ///parameter
  String text4;

  ///parameter

  Products(this.imagepath, this.text1, this.text2, this.text3, this.text4);
}

///Widget Class
class ListItems {
  ///parameter
  IconData icon;

  ///parameter
  String text1;

  ListItems(this.icon, this.text1);
}

///Widget Class
class User {
  ///parameter
  String imagepath;

  ///parameter
  String username;

  ///parameter
  String useremailid;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  double fontSize;

  ///parameter
  Color fontColor;

  ///parameter
  Color headerColor;

  ///parameter

  User(this.imagepath, this.username, this.useremailid, this.fontColor,
      this.fontWeight, this.fontSize, this.headerColor);
}

///Widget Class
class VTabBarProducts {
  ///parameter
  String text;

  ///parameter
  IconData icons;

  ///parameter
  Widget widget;

  VTabBarProducts(this.text, this.icons, this.widget);
}

///Widget Class
class ButtonBarParameters {
  ///parameter
  List<ButtonBarList> list;

  ///parameter
  Color buttonbgColor;

  ///parameter
  Color textColor;

  ///parameter
  Color disabledTextColor;

  ///parameter
  double highlightElevation;

  ///parameter
  double elevation;

  ///parameter
  double disabledElevation;

  ///parameter
  Color hoverColor;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color focusColor;

  ///parameter
  double buttonBorderRadius;

  ///parameter
  ButtonBarParameters(
      {this.list,
      this.buttonbgColor,
      this.textColor,
      this.disabledTextColor,
      this.highlightElevation,
      this.elevation,
      this.disabledElevation,
      this.hoverColor,
      this.borderColor,
      this.borderWidth,
      this.focusColor,
      this.buttonBorderRadius});
}

///Widget Class
class ButtonBarList {
  ///parameter
  String text;

  ///parameter
  Icon icons;
  ButtonBarList(this.text, this.icons);
}

///Widget Class
class TabBarViewParameters {
  ///parameter
  Color backgroundColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color indicatorColor;

  ///parameter
  Color unselectedLabelColor;

  ///parameter
  Color boxShadowColor;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color boxColor;

  ///parameter
  BorderRadiusGeometry borderRadius;

  ///parameter
  List<TabBarProducts> listTabs;

  TabBarViewParameters({
    this.backgroundColor,
    this.labelColor,
    this.indicatorColor,
    this.unselectedLabelColor,
    this.boxShadowColor,
    this.borderColor,
    this.borderWidth,
    this.boxColor,
    this.borderRadius,
    this.listTabs,
  });
}

///Widget Class
class TabBarProducts {
  ///parameter
  String text;

  ///parameter
  Icon icons;

  ///parameter
  Widget widget;

  TabBarProducts(this.text, this.icons, this.widget);
}

///Widget Class
class TabBarParameters {
  ///parameter
  Color backgroundColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color indicatorColor;

  ///parameter
  Color unselectedLabelColor;

  ///parameter
  Color boxShadowColor;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color boxColor;

  ///parameter
  BorderRadiusGeometry borderRadius;

  ///parameter
  List<TabBarList> tablist;

  TabBarParameters({
    this.backgroundColor,
    this.labelColor,
    this.indicatorColor,
    this.unselectedLabelColor,
    this.boxShadowColor,
    this.borderColor,
    this.borderWidth,
    this.boxColor,
    this.borderRadius,
    this.tablist,
  });
}

///Widget Class
class TabBarList {
  ///parameter
  String text;

  ///parameter
  Icon icons;

  ///parameter
  TabBarList(this.text, this.icons);
}

///Widget Class
class AppBarParameters {
  ///parameter
  final Widget leading;

  ///parameter
  final bool automaticallyImplyLeading;

  ///parameter
  final Widget title;

  ///parameter
  final List<Widget> actions;

  ///parameter
  final Widget flexibleSpace;

  ///parameter
  PreferredSizeWidget bottom;

  ///parameter
  final double elevation;

  ///parameter
  final ShapeBorder shape;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Brightness brightness;

  ///parameter
  final IconThemeData iconTheme;

  ///parameter
  final IconThemeData actionsIconTheme;

  ///parameter
  final TextTheme textTheme;

  ///parameter
  final bool primary;

  ///parameter
  final bool centerTitle;

  ///parameter
  final bool excludeHeaderSemantics;

  ///parameter
  final double titleSpacing;

  ///parameter
  final double toolbarOpacity;

  ///parameter
  final double bottomOpacity;

  ///parameter
  Widget searchBar;

  AppBarParameters(
      {this.leading,
      this.automaticallyImplyLeading,
      this.title,
      this.actions,
      this.flexibleSpace,
      this.bottom,
      this.elevation,
      this.shape,
      this.backgroundColor,
      this.brightness,
      this.iconTheme,
      this.actionsIconTheme,
      this.textTheme,
      this.primary,
      this.centerTitle,
      this.excludeHeaderSemantics,
      this.titleSpacing,
      this.toolbarOpacity,
      this.bottomOpacity,
      this.searchBar});
}

///Widget Class
class BottomNavBarParameters {
  ///parameter
  final List<BottomNavigationBarItem> items;

  ///parameter
  final ValueChanged onTap;

  ///parameter
  final int currentIndex;

  ///parameter
  final double elevation;

  ///parameter
  final BottomNavigationBarType type;

  ///parameter
  final Color fixedColor;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final double iconSize;

  ///parameter
  final Color selectedItemColor;

  ///parameter
  final Color unselectedItemColor;

  ///parameter
  final IconThemeData selectedIconTheme;

  ///parameter
  final IconThemeData unselectedIconTheme;

  ///parameter
  final double selectedFontSize;

  ///parameter
  final double unselectedFontSize;

  ///parameter
  final TextStyle selectedLabelStyle;

  ///parameter
  final TextStyle unselectedLabelStyle;

  ///parameter
  final bool showSelectedLabels;

  ///parameter
  final bool showUnselectedLabels;

  BottomNavBarParameters({
    this.items,
    this.onTap,
    this.currentIndex,
    this.elevation,
    this.type,
    this.fixedColor,
    this.backgroundColor,
    this.iconSize,
    this.selectedItemColor,
    this.unselectedItemColor,
    this.selectedIconTheme,
    this.unselectedIconTheme,
    this.selectedFontSize,
    this.unselectedFontSize,
    this.selectedLabelStyle,
    this.unselectedLabelStyle,
    this.showSelectedLabels,
    this.showUnselectedLabels,
  });
}

///Widget Class
class SliverAppBarParameters {
  ///parameter
  final Widget leading;

  ///parameter
  final bool automaticallyImplyLeading;

  ///parameter
  final Widget title;

  ///parameter
  final List<Widget> actions;

  ///parameter
  final Widget flexibleSpace;

  ///parameter
  PreferredSizeWidget bottom;

  ///parameter
  final double elevation;

  ///parameter
  final bool forceElevated;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Brightness brightness;

  ///parameter
  final IconThemeData iconTheme;

  ///parameter
  final IconThemeData actionsIconTheme;

  ///parameter
  final TextTheme textTheme;

  ///parameter
  final bool primary;

  ///parameter
  final bool centerTitle;

  ///parameter
  final bool excludeHeaderSemantics;

  ///parameter
  final double titleSpacing;

  ///parameter
  final double expandedHeight;

  ///parameter
  final bool floating;

  ///parameter
  final bool pinned;

  ///parameter
  final bool snap;

  ///parameter
  final bool stretch;

  ///parameter
  final double stretchTriggerOffset;

  ///parameter
  final AsyncCallback onStretchTrigger;

  ///parameter
  final ShapeBorder shape;

  SliverAppBarParameters(
      {this.leading,
      this.automaticallyImplyLeading,
      this.title,
      this.actions,
      this.flexibleSpace,
      this.bottom,
      this.elevation,
      this.forceElevated,
      this.backgroundColor,
      this.brightness,
      this.iconTheme,
      this.actionsIconTheme,
      this.textTheme,
      this.primary,
      this.centerTitle,
      this.excludeHeaderSemantics,
      this.titleSpacing,
      this.expandedHeight,
      this.floating,
      this.pinned,
      this.snap,
      this.stretch,
      this.stretchTriggerOffset,
      this.onStretchTrigger,
      this.shape});
}

///Widget Class
class CarouselClass {
  ///parameter
  Widget widget;

  ///parameter
  String text1;

  ///parameter
  Animation animation;

  CarouselClass({this.widget, this.text1, this.animation});
}

///Widget Class
class CarouselClass1 {
  ///parameter
  Widget widget;

  ///parameter
  String text1;

  ///parameter
  Cubic animation;

  ///parameter
  Duration animationDuration;

  CarouselClass1(
      {this.widget, this.text1, this.animation, this.animationDuration});
}

///Widget Class
class CustomcompositeCardParameters {
  ///parameter
  int flexColumn1;

  ///parameter
  int flexColumn2;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  List<Widget> leftHandWidgets;

  ///parameter
  List<Widget> rightHandWidgets;

  ///parameter
  double margin;

  ///parameter
  double elevation;

  ///parameter
  Color cardColor;

  ///parameter
  Color shadowColor;

  ///parameter
  double shadowSpread;

  ///parameter
  double textSpacing;

  CustomcompositeCardParameters(
      {this.flexColumn1,
      this.flexColumn2,
      this.title,
      this.subtitle,
      this.leftHandWidgets,
      this.rightHandWidgets,
      this.margin,
      this.elevation,
      this.cardColor,
      this.shadowColor,
      this.shadowSpread,
      this.textSpacing});
}

///Widget Class
class SliderParameters {
  ///parameter
  final String label;

  ///parameter
  final Color activeColor;

  ///parameter
  final int divisions;

  ///parameter
  final Color inactiveColor;

  ///parameter
  final double max;

  ///parameter
  final double min;

  ///parameter
  final ValueChanged<double> onChanged;

  ///parameter
  final ValueChanged<double> onChangeEnd;

  ///parameter
  final ValueChanged<double> onChangeStart;

  ///parameter
  final SemanticFormatterCallback semanticFormatterCallback;

  ///parameter
  final double value;

  SliderParameters({
    Key key,
    this.label,
    this.activeColor,
    this.divisions,
    this.inactiveColor,
    this.max,
    this.min,
    this.onChanged,
    this.onChangeEnd,
    this.onChangeStart,
    this.semanticFormatterCallback,
    this.value,
  });
}

///Widget Class
class AlertDialogContents {
  ///parameter
  List<Widget> buttons;

  ///parameter
  String content;

  ///parameter
  Widget title;

  AlertDialogContents(this.buttons, this.content, this.title);
}

///Widget Class
class AlertDialogParameters {
  ///parameter
  final Widget title;

  ///parameter
  final EdgeInsetsGeometry titlePadding;

  ///parameter
  final TextStyle titleTextStyle;

  ///parameter
  final Widget content;

  ///parameter
  final EdgeInsetsGeometry contentPadding;

  ///parameter
  final TextStyle contentTextStyle;

  ///parameter
  final List<Widget> actions;

  ///parameter
  final EdgeInsetsGeometry actionsPadding;

  ///parameter
  final VerticalDirection actionsOverflowDirection;

  ///parameter
  final double actionsOverflowButtonSpacing;

  ///parameter
  final EdgeInsetsGeometry buttonPadding;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final double elevation;

  ///parameter
  final String semanticLabel;

  ///parameter
  final EdgeInsets insetPadding;

  ///parameter
  final Clip clipBehavior;

  ///parameter
  final ShapeBorder shape;

  ///parameter
  final bool scrollable;

  ///parameter
  final double height;

  ///parameter
  final double width;

  AlertDialogParameters({
    Key key,
    this.title,
    this.titlePadding,
    this.titleTextStyle,
    this.content,
    this.contentPadding = const EdgeInsets.fromLTRB(24.0, 20.0, 24.0, 24.0),
    this.contentTextStyle,
    this.actions,
    this.actionsPadding = EdgeInsets.zero,
    this.actionsOverflowDirection,
    this.actionsOverflowButtonSpacing,
    this.buttonPadding,
    this.backgroundColor,
    this.elevation,
    this.semanticLabel,
    this.insetPadding,
    this.clipBehavior = Clip.none,
    this.shape,
    this.scrollable = false,
    this.height,
    this.width,
  });
}

///Widget Class
class BottomSheetContents {
  ///parameter
  IconButton iconB;

  ///parameter
  String text1;

  BottomSheetContents(this.iconB, this.text1);
}

///Widget Class
class BottomSheetParameters {
  ///parameter
  final AnimationController animationController;

  ///parameter
  final bool enableDrag;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final double elevation;

  ///parameter
  final ShapeBorder shape;

  ///parameter
  final Clip clipBehavior;

  ///parameter
  final VoidCallback onClosing;

  ///parameter
  final WidgetBuilder builder;

  ///parameter
  final double itemExtent;

  ///parameter
  final double height;

  ///parameter
  final Color iconColor;

  ///parameter
  final Color fontColor;

  ///parameter
  final double contentSize;

  BottomSheetParameters(
      {Key key,
      this.animationController,
      this.enableDrag = true,
      this.backgroundColor,
      this.elevation,
      this.shape,
      this.clipBehavior,
      this.onClosing,
      this.builder,
      this.itemExtent,
      this.height,
      this.fontColor,
      this.iconColor,
      this.contentSize});
}

///Widget Class
class SwitchParameters {
  ///parameter
  final ImageProvider activeThumbImage;

  ///parameter
  final Color activeColor;

  ///parameter
  final Color activeTrackColor;

  ///parameter
  final Color focusColor;

  ///parameter
  final Color hoveColor;

  ///parameter
  final Color inactiveTrackColor;

  ///parameter
  final bool autofocus;

  ///parameter
  final FocusNode focusNode;

  ///parameter
  final ImageProvider inactiveThumbImage;

  ///parameter
  final MaterialTapTargetSize materialTapTargetSize;

  ///parameter
  final ImageErrorListener onActiveThumbImageError;

  ///parameter
  final ValueChanged<bool> onChanged;

  ///parameter
  final ImageErrorListener onInactiveThumbImageError;

  ///parameter
  final bool value;

  SwitchParameters({
    Key key,
    this.activeThumbImage,
    @required this.activeColor,
    this.materialTapTargetSize,
    this.focusNode,
    this.autofocus,
    this.onChanged,
    this.value,
    @required this.activeTrackColor,
    this.focusColor,
    this.hoveColor,
    this.inactiveThumbImage,
    this.inactiveTrackColor,
    this.onActiveThumbImageError,
    this.onInactiveThumbImageError,
  });
}

///Widget Class
class TextFieldParameters {
  ///parameter
  final bool autocorrect;

  ///parameter
  final bool autofocus;

  ///parameter
  final InputCounterWidgetBuilder buildCounter;

  ///parameter
  final TextEditingController controller;

  ///parameter
  final Color cursorColor;

  ///parameter
  final Radius cursorRadius;

  ///parameter
  final double cursorWidth;

  ///parameter
  final InputDecoration decoration;

  ///parameter
  final bool enabled;

  ///parameter
  final bool enableInteractiveSelection;

  ///parameter
  final bool enableSuggestions;

  ///parameter
  final bool expands;

  ///parameter
  final FocusNode focusNode;

  ///parameter
  final Brightness keyboardAppearances;

  ///parameter
  final TextInputType keyboardType;

  ///parameter
  final int maxLength;

  ///parameter
  final bool maxLengthEnforced;

  ///parameter
  final int maxLines;

  ///parameter
  final int minLines;

  ///parameter
  final bool obsecureText;

  ///parameter
  final ValueChanged<String> onChanged;

  ///parameter
  final VoidCallback onEditingComplete;

  ///parameter
  final ValueChanged<String> onSubmitted;

  ///parameter
  final GestureTapCallback onTap;

  ///parameter
  final bool readOnly;

  ///parameter
  final ScrollController scrollController;

  ///parameter
  final EdgeInsets scrollPadding;

  ///parameter
  final ScrollPhysics scrollPhysics;

  ///parameter
  final bool selectionEnabled;

  ///parameter
  final bool showCursor;

  ///parameter
  final StrutStyle strutStyle;

  ///parameter
  final TextStyle style;

  ///parameter
  final TextAlign textAlign;

  ///parameter
  final TextAlignVertical textAlignVertical;

  ///parameter
  final TextCapitalization textCapitalization;

  ///parameter
  final TextDirection textDirection;

  ///parameter
  final TextInputAction textInputAction;

  ///parameter
  final ToolbarOptions toolbarOptions;
  final Color fillColor;
  final Color borderColor;

  TextFieldParameters({
    Key key,
    this.toolbarOptions,
    this.textInputAction,
    this.textDirection,
    this.textCapitalization,
    this.textAlignVertical,
    this.textAlign,
    this.style,
    this.strutStyle,
    this.scrollPhysics,
    this.scrollController,
    this.focusNode,
    this.decoration,
    this.controller,
    this.onChanged,
    this.autocorrect,
    this.autofocus,
    this.buildCounter,
    this.cursorColor,
    this.cursorRadius,
    this.cursorWidth,
    this.enabled,
    this.enableInteractiveSelection,
    this.enableSuggestions,
    this.expands,
    this.keyboardAppearances,
    this.keyboardType,
    this.maxLength,
    this.maxLengthEnforced,
    this.maxLines,
    this.minLines,
    this.obsecureText,
    this.onEditingComplete,
    this.onSubmitted,
    this.onTap,
    this.readOnly,
    this.scrollPadding,
    this.selectionEnabled,
    this.showCursor,
    this.fillColor,
    this.borderColor,
  });
}

///Widget Class
class CustomImageContents {
  ///parameter
  final String src;

  ///parameter
  final Key key;

  ///parameter
  final double scale = 1.0;

  ///parameter
  final ImageFrameBuilder frameBuilder;

  ///parameter
  final ImageLoadingBuilder loadingBuilder;

  ///parameter
  final ImageErrorListener errorBuilder;

  ///parameter
  final String semanticLabel;

  ///parameter
  final bool excludeFromSemantics;

  ///parameter
  final double width;

  ///parameter
  final double height;

  ///parameter
  final Color color;

  ///parameter
  final BlendMode colorBlendMode;

  ///parameter
  final BoxFit fit;

  ///parameter
  final AlignmentGeometry alignment;

  ///parameter
  final ImageRepeat repeat;

  ///parameter
  final Rect centerSlice;

  ///parameter
  final bool matchTextDirection;

  ///parameter
  final bool gaplessPlayback;

  ///parameter
  final FilterQuality filterQuality;

  ///parameter
  final Map<String, String> headers;

  ///parameter
  final int cacheWidth;

  ///parameter
  final int cacheHeight;

  ///parameter
  final String imageType;

  CustomImageContents({
    this.frameBuilder,
    this.loadingBuilder,
    this.errorBuilder,
    @required this.semanticLabel,
    this.excludeFromSemantics = false,
    this.width,
    this.height,
    this.color,
    this.colorBlendMode,
    this.fit,
    this.alignment = Alignment.center,
    this.repeat = ImageRepeat.noRepeat,
    this.centerSlice,
    this.matchTextDirection = false,
    this.gaplessPlayback = false,
    this.filterQuality = FilterQuality.low,
    this.key,
    this.headers,
    this.cacheWidth,
    this.cacheHeight,
    @required this.src,
    @required this.imageType,
  });
}

///Widget Class
class MaterialCardData {
  ///parameter
  List<Widget> btnGrpList1;

  ///parameter
  List<Widget> btnGrpList2;

  ///parameter
  String imgPath;

  ///parameter
  String headerText;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  String bodyText;

  ///parameter
  String footerText;

  ///parameter
  String btnText;

  ///parameter
  String btnTextOne;

  ///parameter
  String btnTextTwo;

  ///parameter
  String btnViewone;

  ///parameter
  String btnViewtwo;

  ///parameter
  String btnViewthree;

  ///parameter
  Icon icon;

  ///parameter
  double imgHeight;

  ///parameter
  double imgWidth;

  ///parameter
  double containerHeight;

  ///parameter
  double containerWidth;

  ///parameter
  TextStyle textStyle1;

  ///parameter
  TextStyle textStyle2;

  ///parameter
  TextStyle textStyle3;

  ///parameter
  TextStyle textStyle4;

  ///parameter
  TextStyle textStyle5;

  ///parameter
  Decoration imgDecoration;

  ///parameter
  Decoration iconbgDecoration;

  ///parameter
  Decoration containerDecoration;

  ///parameter
  String imgType;

  ///parameter
  Color cardbgColor;

  ///parameter
  Color containerbgColor;

  ///parameter
  Color dividerColor;

  ///parameter
  Color ratingBarColor;

  ///parameter
  double initialRating;

  ///parameter
  void Function(double) onRatingUpdate;

  ///parameter
  bool iconVisibility;

  ///parameter
  bool visibilityCardHeaderTile;

  ///parameter
  bool visibilityCardImage;

  ///parameter
  bool visibilityCardFooter;

  ///parameter
  bool visibilityCardData;

  ///parameter
  bool visibilityCardActionBar;

  ///parameter
  FlipDirection flipDirection;

  ///parameter
  int flipSpeed;

  ///parameter
  Decoration decoration1;

  ///parameter
  Decoration decoration2;

  ///parameter
  double margin1;

  ///parameter
  double margin2;

  ///parameter
  double margin3;

  ///parameter
  double margin4;

  ///parameter
  double padding1;

  ///parameter
  double padding2;

  ///parameter
  double padding3;

  ///parameter
  double padding4;

  ///parameter
  Color btnColor;

  ///parameter
  ShapeBorder shapeButton;

  ///parameter
  double cardOpacity;

  ///parameter
  double elevation;

  ///parameter
  Color btnTextColor;

  ///parameter
  int imageFlex;

  ///parameter
  int text1Flex;

  ///parameter
  int text2Flex;

  ///parameter
  int text3Flex;

  ///parameter
  int text4Flex;

  ///parameter
  double borderRadius;

  ///parameter
  double borderWidth;

  ///parameter
  Color borderColor;

  ///parameter
  BoxShadow boxShadow;

  MaterialCardData(
      {@required this.btnGrpList1,
      @required this.btnGrpList2,
      @required this.imgPath,
      @required this.headerText,
      @required this.title,
      @required this.subtitle,
      @required this.bodyText,
      @required this.footerText,
      @required this.btnText,
      @required this.icon,
      @required this.imgHeight,
      @required this.imgWidth,
      @required this.containerHeight,
      @required this.containerWidth,
      @required this.textStyle1,
      @required this.textStyle2,
      @required this.textStyle3,
      @required this.textStyle4,
      @required this.textStyle5,
      @required this.btnViewone,
      @required this.imgDecoration,
      @required this.iconbgDecoration,
      @required this.containerDecoration,
      @required this.imgType,
      @required this.btnTextTwo,
      @required this.cardbgColor,
      @required this.containerbgColor,
      @required this.btnTextOne,
      @required this.btnViewtwo,
      @required this.btnViewthree,
      @required this.dividerColor,
      @required this.iconVisibility,
      @required this.visibilityCardHeaderTile,
      @required this.visibilityCardImage,
      @required this.visibilityCardFooter,
      @required this.visibilityCardData,
      @required this.visibilityCardActionBar,
      @required this.onRatingUpdate,
      @required this.flipSpeed,
      @required this.flipDirection,
      @required this.decoration1,
      @required this.decoration2,
      @required this.margin1,
      @required this.margin2,
      @required this.margin3,
      @required this.margin4,
      @required this.padding1,
      @required this.padding2,
      @required this.padding3,
      @required this.padding4,
      @required this.btnColor,
      @required this.shapeButton,
      @required this.elevation,
      @required this.cardOpacity,
      @required this.btnTextColor,
      @required this.initialRating,
      @required this.ratingBarColor,
      this.text4Flex,
      this.text3Flex,
      this.text2Flex,
      this.text1Flex,
      this.imageFlex,
      this.boxShadow,
      this.borderColor,
      this.borderWidth,
      this.borderRadius});
}

///Widget Class
class PaginatedDataTableData {
  ///parameter
  String headerText;

  ///parameter
  bool sortAscending;

  ///parameter
  int sortColumnIndex;

  ///parameter
  double columnSpacing;

  ///parameter
  double dataRowHeight;

  ///parameter
  double horizontalMargin;

  ///parameter
  List<int> availableRowsPerPage;

  ///parameter
  List<DataColumn> columns;

  ///parameter
  DataTableSource tableData;

  ///parameter
  ThemeData theme;

  ///parameter
  int rowsPerPage;

  ///parameter
  List<Widget> actions;
  PaginatedDataTableData(
      {@required this.availableRowsPerPage,
      @required this.columnSpacing,
      @required this.dataRowHeight,
      @required this.horizontalMargin,
      @required this.rowsPerPage,
      @required this.tableData,
      @required this.headerText,
      @required this.sortAscending,
      @required this.sortColumnIndex,
      @required this.actions,
      @required this.theme,
      @required this.columns});
}

///Widget Class
class SnackBarData {
  ///parameter
  String snackBarButtonText;

  ///parameter
  String snackBarContent;

  ///parameter
  String snackBarLabel;

  ///parameter
  Color bgColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color textColor;

  ///parameter
  ShapeBorder shapeBorder;

  ///parameter
  int duration;

  SnackBarData(
      {@required this.snackBarButtonText,
      @required this.snackBarContent,
      @required this.snackBarLabel,
      @required this.bgColor,
      @required this.labelColor,
      @required this.textColor,
      @required this.shapeBorder,
      @required this.duration});
}

///Widget Class
class ExpandablePanelData {
  ///parameter
  final String title;

  ///parameter
  final Icon icon;

  ///parameter
  final List<Widget> widget;

  ///parameter
  final ThemeData themeData;

  ///parameter
  ExpandablePanelData(this.title, this.icon, this.widget, this.themeData);
}

///Widget Class
class MaterialChipData {
  ///parameter
  String labelText;

  ///parameter
  String tooltipMsg;

  ///parameter
  String deleteMsg;

  ///parameter
  Color checkmarkColor;

  ///parameter
  Color bgColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color selectedbgColor;

  ///parameter
  ShapeBorder shapeBorder;

  MaterialChipData(
      {@required this.labelText,
      @required this.tooltipMsg,
      @required this.deleteMsg,
      @required this.checkmarkColor,
      @required this.bgColor,
      @required this.labelColor,
      @required this.shapeBorder,
      @required this.selectedbgColor});
}

///Widget Class
class SimpleDialogData {
  ///parameter
  String dialogHeader;

  ///parameter
  String dialogContent;

  ///parameter
  String dialogButtonText;

  ///parameter
  double height;

  ///parameter
  double width;

  ///parameter
  ShapeBorder shapeBorder;

  ///parameter
  Color bgColor;

  ///parameter
  Color headerTextColor;

  ///parameter
  Color bodyTextColor;

  ///parameter
  Color btnTextColor;

  ///parameter
  Color btnColor;

  SimpleDialogData(
      {@required this.dialogHeader,
      @required this.dialogContent,
      @required this.dialogButtonText,
      @required this.height,
      @required this.width,
      @required this.shapeBorder,
      @required this.bgColor,
      @required this.headerTextColor,
      @required this.bodyTextColor,
      @required this.btnTextColor,
      @required this.btnColor});
}

///Widget Class
class CustomTileData {
  ///parameter
  Widget leading;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  String trailingTopText;

  ///parameter
  String trailingBottomText;

  ///parameter
  bool enabled;

  ///parameter
  bool selected;

  ///parameter
  bool stubMode;

  CustomTileData(
      {this.leading,
      this.title,
      this.subtitle,
      this.trailingTopText,
      this.trailingBottomText,
      this.enabled = true,
      this.selected = false,
      this.stubMode = true});
}

///Widget Class
class CustomListTileParameters {
  ///parameter
  bool isThreeLine;

  ///parameter
  bool dense;

  ///parameter
  EdgeInsetsGeometry contentPadding;

  ///parameter
  GestureTapCallback onTap;

  ///parameter
  GestureLongPressCallback onLongPress;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  double fontSize;

  ///parameter
  String fontFamily;

  ///parameter
  Color textColor;

  ///parameter
  Color listBgColor;

  ///parameter
  Color iconBgColor;

  ///parameter
  double circularRadius;

  ///parameter
  double listHeight;

  ///parameter
  double listWidth;

  ///parameter
  double iconHeight;

  ///parameter
  double iconWidth;

  CustomListTileParameters(
      {this.isThreeLine = false,
      this.dense,
      this.contentPadding,
      this.onTap,
      this.onLongPress,
      this.textColor,
      this.fontFamily,
      this.fontWeight,
      this.fontSize,
      this.circularRadius,
      this.iconBgColor,
      this.listBgColor,
      this.listHeight,
      this.iconHeight,
      this.iconWidth,
      this.listWidth});
}

///Widget Class
class DropDownParameters {
  ///parameter
  String hintText;

  ///parameter
  List<String> itemsList;

  ///parameter
  String listType;

  ///parameter
  Color textColor;

  ///parameter
  Color hintTextColor;

  ///parameter
  FontWeight hintFontWeight;

  ///parameter
  FontStyle hintFontStyle;

  ///parameter
  double hintFontSize;

  ///parameter
  String hintfontFamily;

  ///parameter
  Color fillColor;

  ///parameter
  Color itemsBgColor;

  ///parameter
  Color iconEnabledColor;

  ///parameter
  TextAlign textAlign;

  ///parameter
  double width;

  ///parameter
  double height;

  ///parameter
  double imageWidth;

  ///parameter
  double imageHeight;

  ///parameter
  String fontFamily;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  FontStyle fontStyle;

  ///parameter
  double fontSize;

  ///parameter
  double shadowBlurRadius;

  ///parameter
  double shadowSpreadRadius;

  ///parameter
  double shadowOffsetX;

  ///parameter
  double shadowOffsetY;

  ///parameter
  double borderRadius;

  ///parameter
  Color shadowColor;

  ///parameter
  Key key;

  DropDownParameters(
      {@required this.itemsList,
      this.hintText,
      this.textColor,
      this.height,
      this.width,
      this.fontFamily,
      this.fontStyle,
      this.fontWeight,
      this.fontSize,
      this.fillColor,
      this.imageWidth,
      this.imageHeight,
      this.textAlign,
      this.shadowBlurRadius,
      this.shadowSpreadRadius,
      this.shadowOffsetX,
      this.shadowOffsetY,
      this.listType,
      this.borderRadius,
      this.itemsBgColor,
      this.iconEnabledColor,
      this.shadowColor,
      this.hintFontSize,
      this.hintFontStyle,
      this.hintFontWeight,
      this.hintTextColor,
      this.hintfontFamily,
      this.key});
}

///Widget Class
class StepperParameters {
  ///parameter
  ScrollPhysics physics;

  ///parameter
  StepperType type;

  ///parameter
  int currentStep;

  ///parameter
  ValueChanged<int> onStepTapped;

  ///parameter
  VoidCallback onStepContinue;

  ///parameter
  VoidCallback onStepCancel;

  ///parameter
  ControlsWidgetBuilder controlsBuilder;

  StepperParameters(
      {Key key,
      this.physics,
      this.type = StepperType.vertical,
      this.currentStep,
      this.onStepTapped,
      this.onStepContinue,
      this.onStepCancel,
      this.controlsBuilder});
}

///Widget Class
class CustomSteps {
  ///parameter
  Widget title;

  ///parameter
  Widget subtitle;

  ///parameter
  Widget content;

  ///parameter
  StepState state;

  ///parameter
  bool isActive;

  CustomSteps(
      {this.title, this.subtitle, this.content, this.state, this.isActive});
}

///Widget Class
class CustomVerticalTabParameters {
  ///parameter
  final Key key;

  ///parameter
  final double tabsWidth;

  ///parameter
  final double itemExtent;

  ///parameter
  final double indicatorWidth;

  ///parameter
  final TextDirection direction;

  ///parameter
  final Color indicatorColor;

  ///parameter
  final bool disabledChangePageFromContentView;

  ///parameter
  final Axis contentScrollAxis;

  ///parameter
  final Color selectedTabBackgroundColor;

  ///parameter
  final Color unselectedTabBackgroundColor;

  ///parameter
  final Color dividerColor;

  ///parameter
  final Duration changePageDuration;

  ///parameter
  final Curve changePageCurve;

  ///parameter
  final Color tabsShadowColor;

  ///parameter
  final double tabsElevation;

  ///parameter
  final Color iconColor;

  ///parameter
  final Color tabsTextColor;

  CustomVerticalTabParameters(
      {this.key,
      this.tabsWidth,
      this.itemExtent,
      this.indicatorWidth,
      this.direction,
      this.indicatorColor,
      this.disabledChangePageFromContentView,
      this.contentScrollAxis,
      this.selectedTabBackgroundColor,
      this.unselectedTabBackgroundColor,
      this.dividerColor,
      this.changePageCurve,
      this.changePageDuration,
      this.tabsShadowColor,
      this.tabsElevation,
      this.iconColor,
      this.tabsTextColor});
}

///Widget Class
class CustomFingerprintParameters {
  ///parameter
  final Widget tapWidget;

  ///parameter
  final String authText;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Color textColor;

  ///parameter
  final double textSize;

  CustomFingerprintParameters(
      {this.tapWidget,
      this.authText,
      this.backgroundColor,
      this.textColor,
      this.textSize});
}

///Icon
class IconState {
  ///parameter
  IconData icon;

  ///parameter
  Color color;

  ///parameter
  double size;

  IconState({this.icon, this.color, this.size});
}

///Sub-Widget model Definition
class Area {
  ///parameter
  String header;

  ///parameter
  Widget widget;

  ///parameter
  String label;

  Area(this.header, this.widget, this.label);
}

///Grid model Definition
class Grid {
  ///parameter
  int count;

  ///parameter
  double crossaxisspacing;

  ///parameter
  double mainaxisspacing;

  ///parameter
  Color cardColour;

  ///parameter
  Color textColour;

  ///parameter
  final void Function(int, String) callback;

  ///parameter
  final void Function(int, String, String) longcallback;
  Grid(
      {this.count,
      this.callback,
      this.longcallback,
      this.crossaxisspacing,
      this.mainaxisspacing,
      this.cardColour,
      this.textColour});
}

///Widget Class
class CustomGrid {
  ///parameter
  int count;

  ///parameter
  double cas;

  ///parameter
  double mas;

  ///parameter
  String cardtype;

  ///parameter
  final void Function(int, String) callback;

  ///parameter
  final void Function(int, String, String) longcallback;
  CustomGrid(this.count, this.callback, this.longcallback, this.cas, this.mas,
      this.cardtype);
}

///Model for the DataTable
class DataTableSchema {
  ///parameter
  RowColumn columns;

  ///parameter
  int sortColumnIndex;

  ///parameter
  bool sortAscending;

  ///parameter
  List<RowColumn> rows;

  ///parameter
  Color backgroundColour;

  ///parameter
  Color rowtextColour;

  ///parameter
  double rowtextSize;

  ///parameter
  Color columntextColour;

  ///parameter
  double columntextSize;

  DataTableSchema(
      {this.columns,
      this.sortColumnIndex,
      this.sortAscending,
      this.rows,
      this.backgroundColour,
      this.rowtextColour,
      this.columntextColour,
      this.columntextSize,
      this.rowtextSize});
}

///Model for rows
class RowColumn {
  ///parameter
  List<String> rowcolumn;

  ///parameter
  RowColumn(this.rowcolumn);
}

///Widget Class
class CustomPainterParameters {
  ///parameter
  Color color;

  ///parameter
  StrokeCap strokeCap;

  ///parameter
  final double strokeWidth;

  CustomPainterParameters({
    this.color,
    this.strokeCap,
    this.strokeWidth,
  });
}

///Widget Class
class CustomCanvasOptionsParameters {
  ///parameter
  double heightColor;

  ///parameter
  double heightThickness;

  ///parameter
  double widthColor;

  ///parameter
  double widthThickness;

  ///parameter
  double fontSizeColour;

  ///parameter
  double fontSizeThickness;

  ///parameter
  Color textColorColour;

  ///parameter
  Color textColorThickness;

  ///parameter
  Color bgColorColour;

  ///parameter
  Color bgColorThickness;

  ///parameter
  String fontFamilyColour;

  ///parameter
  String fontFamilyThickness;

  ///parameter
  FontWeight fontWeightColour;

  ///parameter
  FontWeight fontWeightThickness;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color btnColor;

  CustomCanvasOptionsParameters(
      {this.bgColorColour,
      this.bgColorThickness,
      this.fontFamilyColour,
      this.fontFamilyThickness,
      this.fontSizeColour,
      this.fontSizeThickness,
      this.fontWeightColour,
      this.fontWeightThickness,
      this.heightColor,
      this.heightThickness,
      this.textColorColour,
      this.textColorThickness,
      this.widthColor,
      this.widthThickness,
      this.borderWidth,
      this.borderColor,
      this.btnColor});
}

///Widget Class
class OpportunityDetailsCardData {
  ///parameter
  double height;

  ///parameter
  double width;

  ///parameter
  String amount;

  ///parameter
  String status;

  ///parameter
  String heading;

  ///parameter
  String headingValue;

  ///parameter
  String subheadingOne;

  ///parameter
  String subheadingValueOne;

  ///parameter
  String subheadingTwo;

  ///parameter
  String subheadingValueTwo;

  ///parameter
  Widget subheadingIconOne;

  ///parameter
  Widget subheadingIconTwo;

  ///parameter
  Color backgroundColor;

  ///parameter
  Color statusBackgroundColor;

  ///parameter
  double cardRadius;

  ///parameter
  double statusRadius;

  ///parameter
  String headingTextFamily;

  ///parameter
  String headingValueTextFamily;

  ///parameter
  String subheadingOneTextFamily;

  ///parameter
  String subheadingTwoTextFamily;

  ///parameter
  String subheadingValueOneTextFamily;

  ///parameter
  String subheadingValueTwoTextFamily;

  ///parameter
  String statusTextFamily;

  ///parameter
  double headingTextSize;

  ///parameter
  double headingValueTextSize;

  ///parameter
  double subheadingOneTextSize;

  ///parameter
  double subheadingTwoTextSize;

  ///parameter
  double subheadingValueOneTextSize;

  ///parameter
  double subheadingValueTwoTextSize;

  ///parameter
  double statusTextSize;

  ///parameter
  FontWeight headingTextWeight;

  ///parameter
  FontWeight headingValueTextWeight;

  ///parameter
  FontWeight subheadingOneTextWeight;

  ///parameter
  FontWeight subheadingTwoTextWeight;

  ///parameter
  FontWeight subheadingValueOneTextWeight;

  ///parameter
  FontWeight subheadingValueTwoTextWeight;

  ///parameter
  FontWeight statusTextWeight;

  ///parameter
  Color headingTextColor;

  ///parameter
  Color headingValueTextColor;

  ///parameter
  Color subheadingOneTextColor;

  ///parameter
  Color subheadingTwoTextColor;

  ///parameter
  Color subheadingValueOneTextColor;

  ///parameter
  Color subheadingValueTwoTextColor;

  ///parameter
  Color statusTextColor;

  ///parameter
  bool shadow;

  ///parameter
  Color shadowColor;

  ///parameter
  double shadowOffset;

  ///parameter
  Color border;

  ///parameter
  String amountTextFamily;

  ///parameter
  double amountTextSize;

  ///parameter
  FontWeight amountTextWeight;

  ///parameter
  Color amountTextColor;

  ///parameter
  double cardWidth;

  ///parameter
  double padding;

  OpportunityDetailsCardData(
      {this.height = 300,
      this.width = double.infinity,
      this.amount = 'INR 1.2 Crore',
      this.status = 'Won',
      this.heading = 'Account Name',
      this.headingValue = 'Company Name',
      this.subheadingOne = 'Close Date',
      this.subheadingValueOne = '18/05/2020',
      this.subheadingTwo = 'Record Status',
      this.subheadingValueTwo = 'Lock',
      this.subheadingIconOne,
      this.subheadingIconTwo,
      this.backgroundColor = Colors.white,
      this.statusBackgroundColor = Colors.black,
      this.cardRadius = 6,
      this.statusRadius = 30,
      this.headingTextFamily = 'Roboto',
      this.headingValueTextFamily = 'Roboto',
      this.subheadingOneTextFamily = 'Roboto',
      this.subheadingTwoTextFamily = 'Roboto',
      this.subheadingValueOneTextFamily = 'Roboto',
      this.subheadingValueTwoTextFamily = 'Roboto',
      this.statusTextFamily = 'Roboto',
      this.headingTextSize = 14,
      this.headingValueTextSize = 16,
      this.subheadingOneTextSize = 14,
      this.subheadingTwoTextSize = 14,
      this.subheadingValueOneTextSize = 14,
      this.subheadingValueTwoTextSize = 14,
      this.statusTextSize = 10,
      this.headingTextWeight = FontWeight.bold,
      this.headingValueTextWeight = FontWeight.normal,
      this.subheadingOneTextWeight = FontWeight.bold,
      this.subheadingTwoTextWeight = FontWeight.bold,
      this.subheadingValueOneTextWeight = FontWeight.normal,
      this.subheadingValueTwoTextWeight = FontWeight.normal,
      this.statusTextWeight = FontWeight.normal,
      this.headingTextColor = Colors.black,
      this.headingValueTextColor = Colors.black,
      this.subheadingOneTextColor = Colors.black,
      this.subheadingTwoTextColor = Colors.black,
      this.subheadingValueOneTextColor = Colors.black,
      this.subheadingValueTwoTextColor = Colors.black,
      this.statusTextColor = Colors.white,
      this.shadow = false,
      this.shadowColor = Colors.black,
      this.shadowOffset = 10,
      this.border = Colors.black,
      this.amountTextFamily = 'Roboto',
      this.amountTextSize = 14,
      this.amountTextWeight = FontWeight.bold,
      this.amountTextColor = Colors.orange,
      this.cardWidth = 300,
      this.padding = 20});
}

///Widget Class
class CardWithLeftThumbnailData {
  ///parameter
  Color cardBackgroundColor;

  ///parameter
  double borderRadius;

  ///parameter
  bool shadow;

  ///parameter
  Color shadowColor;

  ///parameter
  double shadowRadius;

  ///parameter
  String heading;

  ///parameter
  Color headingTextColor;

  ///parameter
  double headingTextSize;

  ///parameter
  FontWeight headingTextWeight;

  ///parameter
  String headingTextFamily;

  ///parameter
  double paddingValue;

  ///parameter
  Widget icon;

  ///parameter
  Color iconColor;

  ///parameter
  double iconHeight;

  ///parameter
  double iconWidth;

  ///parameter
  double thumbnailHeight;

  ///parameter
  double thumbnailWidth;

  ///parameter
  Color iconBackgroundColor;

  ///parameter
  Widget leftBottomWidget;

  ///parameter
  Widget rightMiddleWidget;

  ///parameter
  Widget rightBottomWidget;

  CardWithLeftThumbnailData(
      {this.cardBackgroundColor = Colors.black,
      this.borderRadius = 6,
      this.shadow = false,
      this.shadowColor = Colors.black,
      this.shadowRadius = 10,
      this.heading = 'Card Heading',
      this.headingTextColor = Colors.white,
      this.headingTextSize = 14,
      this.headingTextWeight = FontWeight.bold,
      this.headingTextFamily = 'Roboto',
      this.paddingValue = 20,
      this.icon,
      this.iconColor = Colors.black,
      this.iconHeight = 20,
      this.iconWidth = 20,
      this.thumbnailWidth = 50,
      this.thumbnailHeight = 50,
      this.iconBackgroundColor = Colors.white,
      this.leftBottomWidget,
      this.rightMiddleWidget,
      this.rightBottomWidget});
}

///Widget Class
class StatusCardData {
  ///parameter
  double cardHeight;

  ///parameter
  double cardWidth;

  ///parameter
  Color backgroundColor;

  ///parameter
  String heading;

  ///parameter
  String headingTextFamily;

  ///parameter
  double headingTextSize;

  ///parameter
  FontWeight headingTextWeight;

  ///parameter
  Color headingTextColor;

  ///parameter
  String subheading;

  ///parameter
  String subheadingTextFamily;

  ///parameter
  double subheadingTextSize;

  ///parameter
  FontWeight subheadingTextWeight;

  ///parameter
  Color subheadingTextColor;

  ///parameter
  String status;

  ///parameter
  String statusTextFamily;

  ///parameter
  double statusTextSize;

  ///parameter
  FontWeight statusTextWeight;

  ///parameter
  Color statusTextColor;

  ///parameter
  Color statusBackground;

  ///parameter
  double cardRadius;

  ///parameter
  double statusRadius;

  StatusCardData(
      {this.cardHeight = 300,
      this.cardWidth = 200,
      this.backgroundColor = Colors.white,
      this.heading = 'Card Heading',
      this.headingTextFamily = 'Roboto',
      this.headingTextSize = 20,
      this.headingTextWeight = FontWeight.normal,
      this.headingTextColor = Colors.white,
      this.subheading = 'Card Subheading',
      this.subheadingTextFamily = 'Roboto',
      this.subheadingTextSize = 14,
      this.subheadingTextWeight = FontWeight.bold,
      this.subheadingTextColor = Colors.white,
      this.status = 'Status',
      this.statusTextFamily = 'Roboto',
      this.statusTextSize = 10,
      this.statusTextWeight = FontWeight.normal,
      this.statusTextColor = Colors.black,
      this.statusBackground = Colors.white,
      this.cardRadius = 6,
      this.statusRadius = 30});
}

///Widget Class
class PlaceLocation {
  ///parameter
  final double latitude;

  ///parameter
  final double longitude;

  ///parameter
  final String address;

  const PlaceLocation({
    @required this.latitude,
    @required this.longitude,
    this.address,
  });
}

///Widget Class
class ServicesData {
  ///parameter
  final String serviceType;

  ///parameter
  final int serviceNumber;

  ///parameter
  final Color mColor;

  ServicesData(this.serviceType, this.serviceNumber, this.mColor);
}

///Widget Class
class LinearSales {
  ///parameter
  final int year;

  ///parameter
  final int sales;

  LinearSales(this.year, this.sales);
}

///Widget Class
class FlatButtonParameters {
  @required
  Widget child;

  ///parameter
  Color color;

  ///parameter
  Brightness colorBrightness;

  ///parameter
  Color disabledColor;

  ///parameter
  double disabledElevation;

  ///parameter
  Color disabledTextColor;

  ///parameter
  Color focusColor;

  ///parameter
  FocusNode focusNode;

  ///parameter
  double height;

  ///parameter
  Color highlightColor;

  ///parameter
  Color splashColor;

  ///parameter
  Color hoverColor;

  ///parameter
  Color textColor;

  ///parameter
  bool autofocus;

  ///parameter
  double width;

  ///parameter
  ShapeBorder shape;

  ///parameter
  ButtonTextTheme textTheme;

  ///parameter
  Key key;

  FlatButtonParameters(
      {this.child,
      this.color,
      this.colorBrightness,
      this.disabledColor,
      this.disabledElevation,
      this.disabledTextColor,
      this.focusColor,
      this.focusNode,
      this.height,
      this.highlightColor,
      this.splashColor,
      this.textTheme,
      this.hoverColor,
      this.textColor,
      this.autofocus,
      this.shape,
      this.width,
      this.key});
}

///Widget Class
class IconButtonParameters {
  ///parameter
  Color color;

  ///parameter
  IconData icon;

  ///parameter
  double iconSize;

  ///parameter
  Color focusColor;

  ///parameter
  Color hoverColor;

  ///parameter
  Color splashColor;

  ///parameter
  Color highlightColor;

  ///parameter
  Color disabledColor;

  ///parameter
  AlignmentGeometry alignment;

  ///parameter
  bool autofocus;

  ///parameter
  String tooltip;

  IconButtonParameters(
      {this.iconSize,
      this.icon,
      this.color,
      this.disabledColor,
      this.hoverColor,
      this.focusColor,
      this.splashColor,
      this.highlightColor,
      this.alignment,
      this.autofocus,
      this.tooltip});
}

///Widget Class
class Floatingactionbuttonparam {
  @required

  ///parameter
  Widget child;

  ///parameter
  Color backgroundColor;

  ///parameter
  Color foregroundColor;

  ///parameter
  bool isExtended;

  ///parameter
  ShapeBorder shape;

  ///parameter
  Color hoverColor;

  ///parameter
  Color splashColor;

  ///parameter
  Object heroTag;

  ///parameter
  bool autofocus;

  ///parameter
  double elevation;

  ///parameter
  double hoverElevation;

  ///parameter
  double highlightElevation;

  ///parameter
  double focusElevation;

  ///parameter
  double disabledElevation;

  ///parameter
  FocusNode focusNode;

  ///parameter
  Color focusColor;

  ///parameter
  bool mini;

  ///parameter
  String tooltip;

  ///parameter
  void Function(bool) onPressed;

  Floatingactionbuttonparam(
      {this.backgroundColor,
      this.foregroundColor,
      this.isExtended = false,
      this.shape,
      this.hoverColor,
      this.splashColor,
      this.heroTag,
      this.focusNode,
      this.autofocus,
      this.child,
      this.focusColor,
      this.highlightElevation,
      this.elevation,
      this.mini,
      this.hoverElevation,
      this.focusElevation,
      this.disabledElevation,
      this.onPressed,
      this.tooltip});
}

///Widget Class
class Outlinebuttonparam {
  @required

  ///parameter
  Widget child;

  ///parameter
  BorderSide borderSide;

  ///parameter
  Color color;

  ///parameter
  ShapeBorder shape;

  ///parameter
  Color textColor;

  ///parameter
  Color disabledTextColor;

  ///parameter
  Color disabledBorderColor;

  ///parameter
  Color highlightColor;

  ///parameter
  Color hoverColor;

  ///parameter
  Color splashColor;

  ///parameter
  Color borderColor;

  ///parameter
  Color highlightedBorderColor;

  ///parameter
  Color focusColor;

  ///parameter
  double borderWidth;

  ///parameter
  BorderStyle borderStyle;

  ///parameter
  double width;

  ///parameter
  double height;

  ///parameter
  bool autofocus;

  ///parameter
  ButtonTextTheme textTheme;

  ///parameter
  FocusNode focusNode;

  Outlinebuttonparam(
      {this.borderSide,
      this.shape,
      this.textColor,
      this.hoverColor,
      this.highlightColor,
      this.focusColor,
      this.color,
      this.splashColor,
      this.borderColor,
      this.borderStyle,
      this.borderWidth,
      this.height,
      this.width,
      this.child,
      this.autofocus,
      this.focusNode,
      this.disabledTextColor,
      this.highlightedBorderColor,
      this.disabledBorderColor,
      this.textTheme});
}

///Widget Class
class DatePickerParameters {
  ///parameter
  int startMonth;

  ///parameter
  int startYear;

  ///parameter
  int endMonth;

  ///parameter
  int endYear;

  ///parameter
  int initialMonth;

  ///parameter
  int initialYear;

  ///parameter
  Color headerColor;

  ///parameter
  Color bodybgColor;

  ///parameter
  String confirmText;

  ///parameter
  String cancelText;

  ///parameter
  String hintText;

  ///parameter
  TextStyle hintTextStyle;

  ///parameter
  TextStyle buttonTextStyle;

  ///parameter
  TextStyle dayTextStyle;

  ///parameter
  TextStyle monthTextStyle;

  ///parameter
  TextStyle selectedDateStyle;

  ///parameter
  Color onHeaderColor;

  ///parameter
  Color onBodyColor;

  DatePickerParameters(
      {this.startMonth,
      this.startYear,
      this.endMonth,
      this.endYear,
      this.headerColor,
      this.bodybgColor,
      this.initialMonth,
      this.initialYear,
      this.hintText,
      this.cancelText,
      this.confirmText,
      this.buttonTextStyle,
      this.dayTextStyle,
      this.hintTextStyle,
      this.monthTextStyle,
      this.onBodyColor,
      this.onHeaderColor,
      this.selectedDateStyle});
}

///Widget Class
class TimePickerParameters {
  ///parameter
  Color headerColor;

  ///parameter
  Color selectColor;

  ///parameter
  Color bodybgColor;

  ///parameter
  Color timeColor;

  ///parameter
  Color buttonText;

  ///parameter
  String fontFamily;

  ///parameter
  double timeSize;

  ///parameter
  FontWeight fontWeight;

  TimePickerParameters({
    this.headerColor,
    this.bodybgColor,
    this.fontFamily,
    this.fontWeight,
    this.timeColor,
    this.selectColor,
    this.buttonText,
    this.timeSize,
  });
}

///Widget Class
class DrawerListItems {
  Widget leading;
  Widget title;

  DrawerListItems(this.leading, this.title);
}

///Widget Class
class DrawerHeaderParameters {
  ///parameter
  String imageType;

  ///parameter
  String imagepath;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  String fontFamily;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  double fontSize;

  ///parameter
  Color fontColor;

  ///parameter
  Color headerColor;

  ///parameter
  Color listbgColor;

  DrawerHeaderParameters(
      {this.fontFamily,
      this.imageType,
      this.imagepath,
      this.title,
      this.subtitle,
      this.fontColor,
      this.fontWeight,
      this.fontSize,
      this.headerColor,
      this.listbgColor});
}

///Widget Class
class CarouselList {
  @required

  ///parameter
  Widget widget;
  CarouselList({
    this.widget,
  });
}

///Widget Class
class CarouselParameters {
  ///parameter
  double height;

  ///parameter
  double width;

  ///parameter
  double childAspectRatio;
  CarouselParameters({this.height, this.width, this.childAspectRatio});
}

///Widget Class
class GrantsData {
  ///parameter
  final String year;

  ///parameter
  final int grants;

  ///parameter
  final Color mColor;

  GrantsData(this.year, this.grants, this.mColor);
}

///Widget Class
class ScatterChartClass {
  ///parameter
  final String datalabel;

  ///parameter
  final int xValue;

  ///parameter
  final double yPercentage;

  ///parameter
  final double radius;

  ///parameter
  final Color color;

  ScatterChartClass(
      this.datalabel, this.xValue, this.yPercentage, this.radius, this.color);
}
